unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages,
  System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Math, Vcl.StdCtrls,
  GLSpaceText, GLScene, GLTeapot, GLObjects, GLCoordinates, GLWin32Viewer, GLCrossPlatform,
  BaseClasses, GLCadencer, GLGeomObjects;

type

  TfMain = class(TForm)
    GLScene1: TGLScene;
    GLSceneViewer1: TGLSceneViewer;
    GLCamera1: TGLCamera;
    GLDummyCube1: TGLDummyCube;
    GLLightSource1: TGLLightSource;
    GLSpaceText1: TGLSpaceText;
    Panel1: TPanel;
    GLTeapot1: TGLTeapot;
    Button1: TButton;
    GLCadencer1: TGLCadencer;
    CheckBox1: TCheckBox;
    Button2: TButton;
    Button3: TButton;
    GLSpaceText2: TGLSpaceText;
    procedure GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure Button1Click(Sender: TObject);
    procedure GLCadencer1Progress(Sender: TObject; const deltaTime, newTime: Double);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
	 FDX : Integer;
   FDY : Integer;
  public
  end;

var
  fMain: TfMain;

implementation

{$R *.dfm}

procedure TfMain.GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
	FDX := X;
  FDY := Y;
end;

procedure TfMain.GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
	DX : Integer;
  DY : Integer;
begin
  if ssLeft in Shift then begin
  	DX  := FDX - X;
    DY  := FDY - Y;
	  FDX := X;
    FDY := Y;
    GLCamera1.MoveAroundTarget(DY, DX)
  end;
end;

procedure TfMain.FormMouseWheel(Sender: TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint;
  var Handled: Boolean);
begin
	GLCamera1.AdjustDistanceToTarget(Power(1.1, WheelDelta/120));
end;

procedure TfMain.GLCadencer1Progress(Sender: TObject; const deltaTime, newTime: Double);
begin
  if CheckBox1.Checked then begin
    GLTeapot1.Roll(1/50);
  end;
end;

procedure TfMain.Button1Click(Sender: TObject);
var
  GLTeapot: TGLTeapot;
begin
  GLTeapot := TGLTeapot.Create(nil);
  GLDummyCube1.AddChild(GLTeapot);
  GLTeapot.Position.Z := 1;
  Button1.Enabled := False;
end;

procedure TfMain.Button2Click(Sender: TObject);
begin
  GLTeapot1.Scale[0] := GLTeapot1.Scale[0] * 1.5;
  GLTeapot1.Scale[1] := GLTeapot1.Scale[2] * 1.5;
  GLTeapot1.Scale[2] := GLTeapot1.Scale[2] * 1.5;
end;

procedure TfMain.Button3Click(Sender: TObject);
begin
  GLTeapot1.Scale[0] := GLTeapot1.Scale[0] / 1.5;
  GLTeapot1.Scale[1] := GLTeapot1.Scale[2] / 1.5;
  GLTeapot1.Scale[2] := GLTeapot1.Scale[2] / 1.5;
end;

end.
